#!/usr/bin/perl -w
use strict;
use warnings;
use FindBin qw($Bin);
use Data::Dumper;

my %freq;
my %c2f;
my %c2m;

opendir D, "$Bin/ath_pci" or die $!;
my @files = grep {/\.chan$/} readdir D;
closedir D;
my %countries;
for my $f (@files) {
    die "urgh" unless $f =~ /^iwlist.(\d+).chan$/;
    my $country = $1;

    open F, "<$Bin/ath_pci/$f" or die $!;
    while (my $ch = <F>) {
	chomp $ch;
	next unless $ch =~ /Channel 0*(\d+) : (.+)/;
	
	$freq{$1}{$country}++;
	$c2f{$1} = $2;
	$countries{$country}{$1}++;

#	$c2m{$1} = $2*1000;	
    }
    close F;
}

#$Data::Dumper::Sortkeys = 1;
#print Dumper \%c2m;
#die;

# clumps:
my %clump;
my %c2c; # Channel -> clump;
for my $c (keys %countries) {
    my $chs = join ',', sort {$a <=> $b} keys %{$countries{$c}};
    push @{$clump{$chs}}, $c;
    map {$c2c{$_}{$chs}++} sort {$a <=> $b} keys %{$countries{$c}};
}

my @clumps = sort {length($b) <=> length($a) || $a cmp $b} keys %clump; 
print "<tr><th>channel vs. countrycode=</th><th>Frequency</th>";
print join '', map {"<th>$_</th>"} 
map {join ' ', @{$clump{$_}}}
@clumps;
print "</tr>";

for my $ch (sort {$a <=> $b} keys %freq) {
    print "<tr><th>$ch</th><th>$c2f{$ch}</th>";
    print join '', map {"<td>$_</td>"} map {
	$c2c{$ch}{$_} ? 'Yes' : ''
    } @clumps; 
    print "</tr>\n";
}
